package se.softstuff.nb.bundleeditor;

import java.awt.Component;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.*;
import javax.swing.*;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;
import org.netbeans.core.spi.multiview.CloseOperationState;
import org.netbeans.core.spi.multiview.MultiViewElement;
import org.netbeans.core.spi.multiview.MultiViewElementCallback;
import org.openide.awt.UndoRedo;
import org.openide.util.*;
import org.openide.windows.TopComponent;
import se.softstuff.nb.bundleeditor.action.TracerStarStopAction;
import se.softstuff.nb.bundleeditor.editor.EditorTrigger;
import se.softstuff.nb.domain.NbBundleDiff;
import se.softstuff.nb.domain.tracer.HighlightedComponent;
import se.softstuff.nb.domain.NbBundleDiffDataObject;
import se.softstuff.nb.domain.tracer.MarkerUtilities;
import se.softstuff.nb.domain.tracer.TracerManager;
import se.softstuff.nb.domain.tracer.DontMarkThisComponent;
import se.softstuff.nb.domain.tracer.TracerTriggerKeys;

@MultiViewElement.Registration(displayName = "#LBL_NbBundleEdit_LIST",
iconBase = "se/softstuff/nb/bundleeditor/nb_translate.png",
mimeType = "text/nb-bundle-diff+xml",
persistenceType = TopComponent.PERSISTENCE_NEVER,
preferredID = "NbBundleEditor",
position = 2100)
public class NbBundleEditorElement extends javax.swing.JPanel implements MultiViewElement, LookupListener, DontMarkThisComponent  {

    public static final String PROP_COMPONENTNAMEFILTER = "componentNameFilter"; //NOI18N
    public static final String PROP_REGEXP = "regexp"; //NOI18N
    public static final String PROP_REGEXP2 = "regexp2"; //NOI18N
    public static final String PREFERRED_ID = "BundleListTopComponent"; //NOI18N
    private NbBundleDiffDataObject obj;
    private JToolBar toolbar = new JToolBar();
    private transient MultiViewElementCallback callback;
    private String regexp;
    private String regexp2;
    private boolean componentNameFilter;
    private Lookup.Result<HighlightedComponent> lookupResult;
    private BundleRowNodeTableModel bundleTableModel = new BundleRowNodeTableModel();
    private TableRowSorter<TableModel> sorter;
    private Set<String> memory = new HashSet<String>();
    private final TracerManager manager;
    private TracerStarStopAction markerAction;
    private EditorTrigger editorTrigger;
    
    public NbBundleEditorElement(Lookup lkp) {
        
        obj = lkp.lookup(NbBundleDiffDataObject.class);
        assert obj != null;
        initComponents();

        model.setup(lkp);
        
        bundelTable.putClientProperty("terminateEditOnFocusLost", Boolean.TRUE); //NOI18N
        sorter = new TableRowSorter<TableModel>(bundleTableModel);
        bundelTable.setRowSorter(sorter);
        manager = (TracerManager) Lookup.getDefault().lookup(TracerManager.class);

        markerAction = new TracerStarStopAction();
        

        toolbar.add(markerAction);

        addPropertyChangeListener(new PropertyChangeListener() {

            @Override
            public void propertyChange(PropertyChangeEvent evt) {
                if (evt.getPropertyName().equals(PROP_COMPONENTNAMEFILTER) || evt.getPropertyName().equals(PROP_REGEXP) || evt.getPropertyName().equals(PROP_REGEXP2)) {
                    sorter.setRowFilter(buildFilter());
                }
            }
        });
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        model = new se.softstuff.nb.bundleeditor.NbBundleEditorElementtPresentationModel();
        jScrollPane1 = new javax.swing.JScrollPane();
        bundelTable = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        compNameCheckBox = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        filterRegExpTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        filterRegExpTextField2 = new javax.swing.JTextField();
        hotKeyPanel = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        markerOnShiftCheckBox = new javax.swing.JCheckBox();
        markerOnMouseComboBox = new javax.swing.JComboBox();
        markerOnAltCheckBox = new javax.swing.JCheckBox();
        markerOnCtrlCheckBox = new javax.swing.JCheckBox();
        keysLabel = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        langLabel = new javax.swing.JLabel();

        bundelTable.setAutoCreateRowSorter(true);
        bundelTable.setModel(bundleTableModel);
        jScrollPane1.setViewportView(bundelTable);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(org.openide.util.NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.jPanel1.border.title"))); // NOI18N

        compNameCheckBox.setText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.compNameCheckBox.text")); // NOI18N

        jLabel1.setText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.jLabel1.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        jLabel1.setToolTipText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.jLabel1.toolTipText", Locale.getDefault().getDisplayLanguage())); // NOI18N

        jLabel3.setText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.jLabel3.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        jLabel3.setToolTipText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.jLabel3.toolTipText", Locale.getDefault().getDisplayLanguage())); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(filterRegExpTextField)
                    .addComponent(filterRegExpTextField2)
                    .addComponent(compNameCheckBox, javax.swing.GroupLayout.DEFAULT_SIZE, 181, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(compNameCheckBox)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(filterRegExpTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(filterRegExpTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        hotKeyPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.hotKeyPanel.border.title"))); // NOI18N
        hotKeyPanel.setName("hotKeyPanel"); // NOI18N

        jLabel2.setText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        markerOnShiftCheckBox.setText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.markerOnShiftCheckBox.text")); // NOI18N
        markerOnShiftCheckBox.setName("markerOnShiftCheckBox"); // NOI18N

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, model, org.jdesktop.beansbinding.ELProperty.create("${startTrigger.shift}"), markerOnShiftCheckBox, org.jdesktop.beansbinding.BeanProperty.create("selected"));
        bindingGroup.addBinding(binding);
        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, model, org.jdesktop.beansbinding.ELProperty.create("${shiftEnabled}"), markerOnShiftCheckBox, org.jdesktop.beansbinding.BeanProperty.create("enabled"));
        bindingGroup.addBinding(binding);

        markerOnMouseComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "left mouse click", "center mouse click", "right mouse click" }));
        markerOnMouseComboBox.setName("markerOnMouseComboBox"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, model, org.jdesktop.beansbinding.ELProperty.create("${startTrigger.mouseButtonIndex}"), markerOnMouseComboBox, org.jdesktop.beansbinding.BeanProperty.create("selectedItem"));
        bindingGroup.addBinding(binding);

        markerOnAltCheckBox.setText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.markerOnAltCheckBox.text")); // NOI18N
        markerOnAltCheckBox.setName("markerOnAltCheckBox"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, model, org.jdesktop.beansbinding.ELProperty.create("${startTrigger.alt}"), markerOnAltCheckBox, org.jdesktop.beansbinding.BeanProperty.create("selected"));
        bindingGroup.addBinding(binding);
        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, model, org.jdesktop.beansbinding.ELProperty.create("${altEnable}"), markerOnAltCheckBox, org.jdesktop.beansbinding.BeanProperty.create("enabled"));
        bindingGroup.addBinding(binding);

        markerOnCtrlCheckBox.setText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.markerOnCtrlCheckBox.text")); // NOI18N
        markerOnCtrlCheckBox.setName("markerOnCtrlCheckBox"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, model, org.jdesktop.beansbinding.ELProperty.create("${startTrigger.ctrl}"), markerOnCtrlCheckBox, org.jdesktop.beansbinding.BeanProperty.create("selected"));
        bindingGroup.addBinding(binding);
        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, model, org.jdesktop.beansbinding.ELProperty.create("${ctrlEnabled}"), markerOnCtrlCheckBox, org.jdesktop.beansbinding.BeanProperty.create("enabled"));
        bindingGroup.addBinding(binding);

        keysLabel.setText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.keysLabel.text")); // NOI18N
        keysLabel.setName("keysLabel"); // NOI18N

        javax.swing.GroupLayout hotKeyPanelLayout = new javax.swing.GroupLayout(hotKeyPanel);
        hotKeyPanel.setLayout(hotKeyPanelLayout);
        hotKeyPanelLayout.setHorizontalGroup(
            hotKeyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, hotKeyPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(hotKeyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(hotKeyPanelLayout.createSequentialGroup()
                        .addComponent(keysLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(hotKeyPanelLayout.createSequentialGroup()
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGroup(hotKeyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, hotKeyPanelLayout.createSequentialGroup()
                                .addGap(150, 150, 150)
                                .addComponent(markerOnMouseComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(hotKeyPanelLayout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(markerOnShiftCheckBox, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(markerOnCtrlCheckBox, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(markerOnAltCheckBox))))))
        );
        hotKeyPanelLayout.setVerticalGroup(
            hotKeyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, hotKeyPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(keysLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(hotKeyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(markerOnShiftCheckBox)
                    .addComponent(markerOnMouseComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(markerOnCtrlCheckBox)
                    .addComponent(markerOnAltCheckBox))
                .addGap(27, 27, 27))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(org.openide.util.NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.jPanel2.border.title"))); // NOI18N
        jPanel2.setName("jPanel2"); // NOI18N

        langLabel.setText(NbBundle.getMessage(NbBundleEditorElement.class, "NbBundleEditorElement.langLabel.text", Locale.getDefault().getDisplayLanguage())); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(langLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 174, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(langLabel)
                .addGap(0, 59, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(hotKeyPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(hotKeyPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 265, Short.MAX_VALUE))
        );

        bindingGroup.bind();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable bundelTable;
    private javax.swing.JCheckBox compNameCheckBox;
    private javax.swing.JTextField filterRegExpTextField;
    private javax.swing.JTextField filterRegExpTextField2;
    private javax.swing.JPanel hotKeyPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel keysLabel;
    private javax.swing.JLabel langLabel;
    private javax.swing.JCheckBox markerOnAltCheckBox;
    private javax.swing.JCheckBox markerOnCtrlCheckBox;
    private javax.swing.JComboBox markerOnMouseComboBox;
    private javax.swing.JCheckBox markerOnShiftCheckBox;
    private se.softstuff.nb.bundleeditor.NbBundleEditorElementtPresentationModel model;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables

    @Override
    public String getName() {
        return "NbBundleEditorElement";
    }

    @Override
    public JComponent getVisualRepresentation() {
        return this;
    }

    @Override
    public JComponent getToolbarRepresentation() {
        return toolbar;
    }

    @Override
    public Action[] getActions() {
        return new Action[]{markerAction};
    }

    @Override
    public Lookup getLookup() {
        return obj.getLookup();
    }

    @Override
    public void componentOpened() {

        lookupResult = manager.getLookup().lookupResult(HighlightedComponent.class);
        lookupResult.addLookupListener(this);
        compNameCheckBox.setSelected(NbPreferences.forModule(this.getClass()).getBoolean("compNameCheckBox.selected", true));
        editorTrigger = new EditorTrigger();
        
        TracerTriggerKeys startTrigger = model.getStartTrigger();
        startTrigger.addPropertyChangeListener(editorTrigger);
        TracerManager tracer = getTracer();
        tracer.attachTrigger(model.getStartTrigger());
        
        reload();
    }

    @Override
    public void componentClosed() {
        NbPreferences.forModule(this.getClass()).putBoolean("compNameCheckBox.selected", compNameCheckBox.isSelected());
        lookupResult.removeLookupListener(this);
        lookupResult = null;
        
        model.saveTriggers();
        TracerManager tracer = getTracer();
        tracer.detatchTrigger();
    }

    @Override
    public void componentShowing() {
    }

    @Override
    public void componentHidden() {
    }

    @Override
    public void componentActivated() {
    }

    @Override
    public void componentDeactivated() {
    }

    @Override
    public UndoRedo getUndoRedo() {
        return UndoRedo.NONE;
    }

    @Override
    public void setMultiViewCallback(MultiViewElementCallback callback) {
        this.callback = callback;
    }

    @Override
    public CloseOperationState canCloseElement() {
        return CloseOperationState.STATE_OK;
    }

    public String getRegexp() {
        return regexp;
    }

    public void setRegexp(String regexp) {
        String oldRegexp = this.regexp;
        this.regexp = regexp;
        firePropertyChange(PROP_REGEXP, oldRegexp, regexp);
    }

    public boolean isComponentNameFilter() {
        return componentNameFilter;
    }

    public void setComponentNameFilter(boolean componentNameFilter) {
        boolean oldComponentNameFilter = this.componentNameFilter;
        this.componentNameFilter = componentNameFilter;
        firePropertyChange(PROP_COMPONENTNAMEFILTER, oldComponentNameFilter, componentNameFilter);
    }

    public String getRegexp2() {
        return regexp2;
    }

    public void setRegexp2(String regexp2) {
        String oldRegexp2 = this.regexp2;
        this.regexp2 = regexp2;
        firePropertyChange(PROP_REGEXP2, oldRegexp2, regexp2);
    }

    @Override
    public void resultChanged(LookupEvent ev) {
        reload();
    }

    private void reload() {
        Collection<? extends HighlightedComponent> allInstances = lookupResult.allInstances();

        memory.clear();
        sorter.setRowFilter(buildFilter());
        bundleTableModel.initHeaders();
        bundleTableModel.clearRows();
        for (HighlightedComponent highlightedComponent : allInstances) {
            List<BundleRowNode> rows = addRowsAndHeadersForComponent(highlightedComponent.getComponent());
            bundleTableModel.addRows(rows);
        }
        bundleTableModel.updateCompleted();
        bundelTable.addNotify();

    }

    private RowFilter<? super TableModel, ? super Integer> buildFilter() {
        List<RowFilter<? super TableModel, ? super Integer>> filters = new LinkedList<RowFilter<? super TableModel, ? super Integer>>();
        Collection<? extends HighlightedComponent> allInstances = lookupResult.allInstances();
        for (HighlightedComponent highlightedComponent : allInstances) {
            if (compNameCheckBox.isSelected()) {
                Component component = highlightedComponent.getComponent();
                String name = component.getName();
                if (name != null) {
                    filters.add(RowFilter.regexFilter(name));
                }
            }
        }
        if (!filterRegExpTextField.getText().isEmpty()) {
            filters.add(RowFilter.regexFilter(filterRegExpTextField.getText()));
        }
        if (!filterRegExpTextField2.getText().isEmpty()) {
            filters.add(RowFilter.regexFilter(filterRegExpTextField2.getText()));
        }
        return RowFilter.andFilter((Iterable) filters);
    }

    private List<BundleRowNode> addRowsAndHeadersForComponent(Component component) {

        List<BundleRowNode> nodes = new LinkedList<BundleRowNode>();
        if (component == null) {
            return nodes;
        }

        Class clazz = component.getClass();
        String bundlePackage = clazz.getPackage().getName();

//        if (!memory.contains(bundlePackage)) {

        MarkerUtilities.BundlePath bundlePath = MarkerUtilities.findAllBundlePaths(clazz);
        if (bundlePath != null) {
            try {

                bundleTableModel.addHeaders(bundlePath.bundleTypes);

                BundleRowEngine engine = new BundleRowEngine(bundlePath);

                ResourceBundle bundle = org.openide.util.editable.NbBundle.getBundle(clazz);
                memory.add(bundlePackage);

                Enumeration<String> keys = bundle.getKeys();
                while (keys.hasMoreElements()) {
                    String key = keys.nextElement();

                    nodes.add(new BundleRowNode(bundlePackage, key, component, engine));
                }
            } catch (java.util.MissingResourceException ignore) {
            }
        }
//        }


        // do not go deeper the the first top component
        if (component instanceof TopComponent) {
            return nodes;
        }

        // the famous last word: this shuld never happen... and its wrong
        List<BundleRowNode> parent = addRowsAndHeadersForComponent(component.getParent());
        if (parent != null) {
            nodes.addAll(parent);
        }
        return nodes;
    }
    
    private TracerManager getTracer() {
        return Lookup.getDefault().lookup(TracerManager.class);
    }
    
}
